//*************************************************************
// Java application
//		uDisplayModeTestv
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOV^P
//@@@@@@@@@@ŏIXVFQOOV^P      [TN098/J88]
//*************************************************************
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DisplayModeTest extends JFrame implements ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;

	public static void main(String[] args) {
		DisplayModeTest frame=new DisplayModeTest();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setSize(400,300);
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//
	//̊ŗp\ȃOtBbNfoCX
	GraphicsDevice device;
	//
	JList list;
	DisplayMode[] modes;	//p\ȃfBXvC[h
	//
	DisplayMode modeNow;	//̃fBXvC[h
	//
	JButton changeButton=new JButton("DisplayModeύX");
	JButton returnButton=new JButton("ɖ߂");
	//
	public DisplayModeTest(){
		setTitle("DisplayModeTest");
		//OtBbNfoCX擾
		device=GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
		//
		modeNow=device.getDisplayMode();
		//
		modes=device.getDisplayModes();
		String[] modesString=new String[modes.length];
		for(int m=0;m<modes.length;m++){
			modesString[m]=modes[m].getWidth()+"w"+modes[m].getHeight()+", "+modes[m].getRefreshRate()+"Hz, BitDepth="+modes[m].getBitDepth();
		}
		//p\ȃfBXvC[ḧꗗ\
		list=new JList(modesString);
		JScrollPane scrollPane=new JScrollPane(list);
		//
		getContentPane().add(scrollPane,BorderLayout.CENTER);
		getContentPane().add(changeButton,BorderLayout.NORTH);
		getContentPane().add(returnButton,BorderLayout.SOUTH);
		//
		changeButton.addActionListener(this);
		returnButton.addActionListener(this);
	}
	//
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==changeButton){
			if(device.isDisplayChangeSupported()){
				//IꂽfBXvC[hiIȂIj
				int selected=list.getSelectedIndex();
				if(selected==-1){
					return;
				}
				//w肳ꂽfBXvC[hɕύX
				device.setDisplayMode(modes[selected]);
				/*ł͏肭Ȃ
				try{
					device.setDisplayMode(modes[selected]);
				}finally{
					device.setDisplayMode(modeNow);	//sI猳ɖ߂悤
				}
				*/
			}else{		//VXeύXĂȂ
				JOptionPane.showMessageDialog(this,"fBXvC[hύX͋eĂ܂","G[",JOptionPane.ERROR_MESSAGE);
			}
		}else if(e.getSource()==returnButton){
			if(device.isDisplayChangeSupported()){
				//̃fBXvC[hɖ߂
				device.setDisplayMode(modeNow);
			}else{		//VXeύXĂȂ
				JOptionPane.showMessageDialog(this,"fBXvC[hύX͋eĂ܂","G[",JOptionPane.ERROR_MESSAGE);
			}
		}
	}

}
